<template>
  <div><slot/></div>
</template>

<script>
import { Control, DomEvent } from 'leaflet'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LeafletGetter from '@/workspace/mixins/LeafletGetter'


export default {
  name: 'mapcontrol',

  mixins: [
    WorkspaceGetter,
    LeafletGetter,
  ],

  props: {
    position: {
      type: String,
      default: 'topright'
    }
  },

  mounted() {
    const CustomControl = Control.extend({
      element: undefined,

      onAdd() {
        return this.element
      },

      setElement(el) {
        this.element = el
      },
    })

    this.__controlObject = new CustomControl({
      position: this.position
    })

    this.__controlObject.setElement(this.$el)
    DomEvent.disableClickPropagation(this.$el)
    this.__controlObject.addTo(this.leafletMap)
  },
}
</script>
